"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var domStyleRenderer_1 = require("./domStyleRenderer");
var hoist_non_react_methods_1 = require("hoist-non-react-methods");
var uniqueId = require('lodash/uniqueId');
var isStatelessComponent = function (Component) { return !(Component.prototype && Component.prototype.render); };
function withClasses(CoreComponent, styles) {
    var ThemedComponent = /** @class */ (function (_super) {
        __extends(ThemedComponent, _super);
        function ThemedComponent(props) {
            var _this = _super.call(this, props) || this;
            _this.wrappedComponentRef = null;
            _this.id = uniqueId();
            _this.state = { classes: domStyleRenderer_1.generateClasses(styles(props.theme), _this.id) };
            return _this;
        }
        ThemedComponent.prototype.componentWillReceiveProps = function (nextProps) {
            if (this.props.theme !== nextProps.theme) {
                this.setState({ classes: domStyleRenderer_1.generateClasses(styles(nextProps.theme), this.id) });
            }
        };
        ThemedComponent.prototype.componentWillUnmount = function () {
            domStyleRenderer_1.detachStyleSheetFromDom(this.id);
        };
        ThemedComponent.prototype.render = function () {
            var _this = this;
            var coreProps = Object.assign({}, this.props, { theme: undefined });
            return isStatelessComponent(CoreComponent)
                ? (React.createElement(CoreComponent, __assign({}, coreProps, { classes: this.state.classes })))
                : (React.createElement(CoreComponent, __assign({ ref: function (ref) { return _this.wrappedComponentRef = ref; } }, coreProps, { classes: this.state.classes })));
        };
        ThemedComponent.displayName = CoreComponent.displayName || 'ThemedComponent';
        return ThemedComponent;
    }(React.PureComponent));
    return isStatelessComponent(CoreComponent)
        ? ThemedComponent
        : hoist_non_react_methods_1.default(ThemedComponent, CoreComponent, { delegateTo: function (c) { return c.wrappedComponentRef; }, hoistStatics: true });
}
exports.withClasses = withClasses;
//# sourceMappingURL=withClasses.js.map